<template>
  <div class="game">
    <span v-if="!mapData">Loading…</span>
    <keybindings />
    <music file-path="wood" />

    <transition name="fade">
      <img
        v-if="characterCardUrl"
        :src="characterCardUrl"
        class="character-card"
      >
    </transition>

    <div
      v-if="activeObstacle"
      class="obstacle-options"
    >
      <button
        v-for="(option, optionIndex) in activeObstacle.availableOptions"
        :key="optionIndex"
        type="button"
        class="option"
        @click="vaporize(option)"
      >
        <span
          v-for="(elementCount, element) in option"
          :key="element"
          class="element-badge"
        >
          {{ elementCount }}
          <img :src="require(`~/static/badges/${element}.png`)">
        </span>
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import Keybindings from '../components/keybindings'
import Music from '../components/music'

export default {
  components: {
    Music,
    Keybindings
  },
  computed: {
    ...mapState([
      'activeObstacle',
      'isDebugMode',
      'mapData',
      'characterCardUrl'
    ])
  },
  mounted() {
    this.createWorld(this.$el).then(() => this.loadMap('wood'))

    document.addEventListener('keypress', this.onKeyPress)
  },
  beforeDestroy() {
    document.removeEventListener('keypress', this.onKeyPress)
  },
  methods: {
    ...mapActions(['createWorld', 'loadMap', 'toggleDebugMode', 'vaporize']),
    onKeyPress({ key }) {
      if (key === 'd') {
        this.toggleDebugMode()
      }
    }
  }
}
</script>

<style scoped>
canvas {
  position: absolute;
}

.obstacle-options {
  display: flex;
  flex-direction: column;
  position: absolute;
  left: 64px;
  top: 64px;
}

.obstacle-options .option {
  background: white;
  border: 8px solid #1e90ff;
  border-radius: 4px;
  color: black;
  cursor: pointer;
  display: flex;
  flex-direction: row;
  font-size: 64px;
  font-weight: bold;
  margin-bottom: 8px;
  opacity: 0.7;
}

.obstacle-options .option:hover {
  opacity: 0.9;
}

.obstacle-options .element-badge {
  display: flex;
  flex-direction: row;
}

.obstacle-options .element-badge img {
  height: 64px;
  margin: 8px;
}

.character-card {
  position: absolute;
  right: 64px;
  top: 50%;
  margin-top: -250px;
}

.game {
  position: relative;
  overflow: hidden;
  height: 100vh;
}

.hidden {
  display: none;
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}
</style>
